<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: proto/table.proto

namespace Keboola\StorageDriver\Command\Table;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 **
 * Command is used when importing file into Keboola connection
 * Command will take source file and import it into backend table based on provided options
 *
 * Generated from protobuf message <code>keboola.storageDriver.command.table.TableImportFromFileCommand</code>
 */
class TableImportFromFileCommand extends \Google\Protobuf\Internal\Message
{
    /**
     * Type of file storage provider
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileProvider fileProvider = 1;</code>
     */
    protected $fileProvider = 0;
    /**
     * Specifies the format of the data files containing source data
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileFormat fileFormat = 2;</code>
     */
    protected $fileFormat = 0;
    /**
     * file format options
     *
     * Generated from protobuf field <code>.google.protobuf.Any formatTypeOptions = 3;</code>
     */
    protected $formatTypeOptions = null;
    /**
     * path to file on cloud storage
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FilePath filePath = 4;</code>
     */
    protected $filePath = null;
    /**
     **
     * credentials used to access file on file storage
     * Use ImportExportShared.{S3Credentials, ABSCredentials}
     *
     * Generated from protobuf field <code>.google.protobuf.Any fileCredentials = 5;</code>
     */
    protected $fileCredentials = null;
    /**
     **
     * Resulting table on the backend
     * Table must exists before import
     * All table properties are loaded from backend
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.Table destination = 6;</code>
     */
    protected $destination = null;
    /**
     **
     * Import options may vary based on backend
     * based on:
     * https://github.com/keboola/php-db-import-export/blob/master/src/ImportOptions.php
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.ImportOptions importOptions = 7;</code>
     */
    protected $importOptions = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $fileProvider
     *           Type of file storage provider
     *     @type int $fileFormat
     *           Specifies the format of the data files containing source data
     *     @type \Google\Protobuf\Any $formatTypeOptions
     *           file format options
     *     @type \Keboola\StorageDriver\Command\Table\ImportExportShared\FilePath $filePath
     *           path to file on cloud storage
     *     @type \Google\Protobuf\Any $fileCredentials
     *          *
     *           credentials used to access file on file storage
     *           Use ImportExportShared.{S3Credentials, ABSCredentials}
     *     @type \Keboola\StorageDriver\Command\Table\ImportExportShared\Table $destination
     *          *
     *           Resulting table on the backend
     *           Table must exists before import
     *           All table properties are loaded from backend
     *     @type \Keboola\StorageDriver\Command\Table\ImportExportShared\ImportOptions $importOptions
     *          *
     *           Import options may vary based on backend
     *           based on:
     *           https://github.com/keboola/php-db-import-export/blob/master/src/ImportOptions.php
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Proto\Table::initOnce();
        parent::__construct($data);
    }

    /**
     * Type of file storage provider
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileProvider fileProvider = 1;</code>
     * @return int
     */
    public function getFileProvider()
    {
        return $this->fileProvider;
    }

    /**
     * Type of file storage provider
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileProvider fileProvider = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setFileProvider($var)
    {
        GPBUtil::checkEnum($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\FileProvider::class);
        $this->fileProvider = $var;

        return $this;
    }

    /**
     * Specifies the format of the data files containing source data
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileFormat fileFormat = 2;</code>
     * @return int
     */
    public function getFileFormat()
    {
        return $this->fileFormat;
    }

    /**
     * Specifies the format of the data files containing source data
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FileFormat fileFormat = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setFileFormat($var)
    {
        GPBUtil::checkEnum($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\FileFormat::class);
        $this->fileFormat = $var;

        return $this;
    }

    /**
     * file format options
     *
     * Generated from protobuf field <code>.google.protobuf.Any formatTypeOptions = 3;</code>
     * @return \Google\Protobuf\Any|null
     */
    public function getFormatTypeOptions()
    {
        return $this->formatTypeOptions;
    }

    public function hasFormatTypeOptions()
    {
        return isset($this->formatTypeOptions);
    }

    public function clearFormatTypeOptions()
    {
        unset($this->formatTypeOptions);
    }

    /**
     * file format options
     *
     * Generated from protobuf field <code>.google.protobuf.Any formatTypeOptions = 3;</code>
     * @param \Google\Protobuf\Any $var
     * @return $this
     */
    public function setFormatTypeOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Any::class);
        $this->formatTypeOptions = $var;

        return $this;
    }

    /**
     * path to file on cloud storage
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FilePath filePath = 4;</code>
     * @return \Keboola\StorageDriver\Command\Table\ImportExportShared\FilePath|null
     */
    public function getFilePath()
    {
        return $this->filePath;
    }

    public function hasFilePath()
    {
        return isset($this->filePath);
    }

    public function clearFilePath()
    {
        unset($this->filePath);
    }

    /**
     * path to file on cloud storage
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.FilePath filePath = 4;</code>
     * @param \Keboola\StorageDriver\Command\Table\ImportExportShared\FilePath $var
     * @return $this
     */
    public function setFilePath($var)
    {
        GPBUtil::checkMessage($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\FilePath::class);
        $this->filePath = $var;

        return $this;
    }

    /**
     **
     * credentials used to access file on file storage
     * Use ImportExportShared.{S3Credentials, ABSCredentials}
     *
     * Generated from protobuf field <code>.google.protobuf.Any fileCredentials = 5;</code>
     * @return \Google\Protobuf\Any|null
     */
    public function getFileCredentials()
    {
        return $this->fileCredentials;
    }

    public function hasFileCredentials()
    {
        return isset($this->fileCredentials);
    }

    public function clearFileCredentials()
    {
        unset($this->fileCredentials);
    }

    /**
     **
     * credentials used to access file on file storage
     * Use ImportExportShared.{S3Credentials, ABSCredentials}
     *
     * Generated from protobuf field <code>.google.protobuf.Any fileCredentials = 5;</code>
     * @param \Google\Protobuf\Any $var
     * @return $this
     */
    public function setFileCredentials($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Any::class);
        $this->fileCredentials = $var;

        return $this;
    }

    /**
     **
     * Resulting table on the backend
     * Table must exists before import
     * All table properties are loaded from backend
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.Table destination = 6;</code>
     * @return \Keboola\StorageDriver\Command\Table\ImportExportShared\Table|null
     */
    public function getDestination()
    {
        return $this->destination;
    }

    public function hasDestination()
    {
        return isset($this->destination);
    }

    public function clearDestination()
    {
        unset($this->destination);
    }

    /**
     **
     * Resulting table on the backend
     * Table must exists before import
     * All table properties are loaded from backend
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.Table destination = 6;</code>
     * @param \Keboola\StorageDriver\Command\Table\ImportExportShared\Table $var
     * @return $this
     */
    public function setDestination($var)
    {
        GPBUtil::checkMessage($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\Table::class);
        $this->destination = $var;

        return $this;
    }

    /**
     **
     * Import options may vary based on backend
     * based on:
     * https://github.com/keboola/php-db-import-export/blob/master/src/ImportOptions.php
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.ImportOptions importOptions = 7;</code>
     * @return \Keboola\StorageDriver\Command\Table\ImportExportShared\ImportOptions|null
     */
    public function getImportOptions()
    {
        return $this->importOptions;
    }

    public function hasImportOptions()
    {
        return isset($this->importOptions);
    }

    public function clearImportOptions()
    {
        unset($this->importOptions);
    }

    /**
     **
     * Import options may vary based on backend
     * based on:
     * https://github.com/keboola/php-db-import-export/blob/master/src/ImportOptions.php
     *
     * Generated from protobuf field <code>.keboola.storageDriver.command.table.ImportExportShared.ImportOptions importOptions = 7;</code>
     * @param \Keboola\StorageDriver\Command\Table\ImportExportShared\ImportOptions $var
     * @return $this
     */
    public function setImportOptions($var)
    {
        GPBUtil::checkMessage($var, \Keboola\StorageDriver\Command\Table\ImportExportShared\ImportOptions::class);
        $this->importOptions = $var;

        return $this;
    }

}

